IKEv1 έναντι IKEv2: έλεγχος ταυτότητας με προκοινοποιημένο κλειδί και τι διαφέρει
Και οι δύο εκδόσεις αποδεικνύουν γνώση του προκοινοποιημένου κλειδιού χωρίς να το στέλνουν, αλλά τροφοδοτούν διαφορετικές εισόδους σε διαφορετικά κατακερματισμούς. Συγκρίνετε τα δύο ίχνη.
Δύο πύλες ρυθμισμένες με το ίδιο προκοινοποιημένο κλειδί ολοκληρώνουν μια χειραψία, και μια καταγραφή πακέτων δεν δείχνει κανένα μυστικό να περνά από το καλώδιο. Αυτό είναι το κομμάτι που θυμούνται οι άνθρωποι. Το ενδιαφέρον κομμάτι είναι τι υπολογίζει πραγματικά κάθε έκδοση για να αποδείξει ότι το μυστικό είναι γνωστό, επειδή τα IKEv1 και IKEv2 χτίζουν αυτή την απόδειξη από διαφορετικές εισόδους και εκθέτουν διαφορετικές πληροφορίες καθώς το κάνουν. Διαβάστε τα δύο ίχνη δίπλα-δίπλα και η διαφορά παύει να είναι καλλωπιστική.
Τι πρέπει να πετύχει η απόδειξη
Το Ντίφι-Χέλμαν δίνει και στους δύο ομοτίμους μια κοινή τιμή της οποίας τα δημόσια μισά μπορεί να υπολογίσει και οποιοσδήποτε παρατηρεί. Από μόνο του αυτό δεν αποδεικνύει τίποτα για την ταυτότητα: ένας επιτιθέμενος που ολοκληρώνει μια ανταλλαγή κλειδιών έχει την ίδια κοινή τιμή με την πύλη σας. Το βήμα ελέγχου ταυτότητας υπάρχει για να δεσμεύσει αυτή την ανταλλαγή σε ένα μυστικό που κατέχουν μόνο οι προβλεπόμενοι ομότιμοι, και στις ταυτότητες και παραμέτρους που συμφώνησαν.
Αυτή η δέσμευση είναι ο λόγος που ο κατακερματισμός καλύπτει περισσότερα από το κλειδί. Αν κάλυπτε μόνο το μυστικό, ένας επιτιθέμενος θα μπορούσε να το αναπαράγει σε διαφορετική ανταλλαγή με διαφορετικές ταυτότητες ή προτάσεις.
IKEv1, κύρια λειτουργία: παράγω το SKEYID και μετά απόδειξέ το
Το Η κύρια λειτουργία εκτελεί έξι μηνύματα. Το πρώτο ζεύγος διαπραγματεύεται τη συσχέτιση ασφαλείας, το δεύτερο ανταλλάσσει δημόσιες τιμές Ντίφι-Χέλμαν και νονς, και το τρίτο μεταφέρει ταυτότητες συν κατακερματισμούς ελέγχου ταυτότητας κάτω από την κρυπτογράφηση που μόλις εγκαταστάθηκε. Το RFC 2409 ορίζει την κατασκευή: με έλεγχο ταυτότητας προκοινοποιημένου κλειδιού, το SKEYID παράγεται από το μυστικό και τα δύο νονς, και το μεταγενέστερο υλικό κλειδιού παράγεται από το SKEYID, την κοινή τιμή Ντίφι-Χέλμαν, τα κούκις και τις σταθερές.
Ο κατακερματισμός στα μηνύματα πέντε και έξι υπολογίζεται πάνω στην τιμή Ντίφι-Χέλμαν, τα δύο κούκις, την πρόταση και την ταυτότητα του αποστολέα, με κλειδί το SKEYID. Ο παραλήπτης το υπολογίζει ξανά με το δικό του ρυθμισμένο μυστικό. Μια ασυμφωνία τερματίζει την ανταλλαγή, και σε κανένα σημείο το μυστικό δεν είναι το ίδιο ωφέλιμο φορτίο.
Το Η επιθετική λειτουργία συμπιέζει την ίδια εργασία σε τρία μηνύματα, που σημαίνει ότι οι ταυτότητες και ο κατακερματισμός ελέγχου ταυτότητας ταξιδεύουν πριν υπάρξει κρυπτογραφημένο κανάλι. Αυτή είναι πραγματική έκθεση για ένα μυστικό που μπορεί να μαντευτεί, και είναι ξεχωριστή από το ερώτημα αν το μυστικό μεταδόθηκε. Το IKEv1 έχει καταργηθεί από το RFC 9395, οπότε ένα παλαιό ίχνος είναι διαγνωστική άσκηση και όχι στόχος ανάπτυξης.
IKEv2: διαφορετική παραγωγή και διαφορετικό ωφέλιμο φορτίο AUTH
Το IKEv2 δεν επαναχρησιμοποιεί το χρονοδιάγραμμα κλειδιών του IKEv1. Τα αρχικά κλειδιά IKE προέρχονται από έναν σπόρο που χτίζεται από τα νονς και την κοινή τιμή Ντίφι-Χέλμαν, και οι θυγατρικές συσχετίσεις ασφαλείας παράγονται από αυτό. Το προκοινοποιημένο κλειδί δεν τροφοδοτεί καθόλου τον σπόρο.
Ο έλεγχος ταυτότητας εμφανίζεται έπειτα ως ωφέλιμο φορτίο AUTH. Για έλεγχο ταυτότητας με κοινό κλειδί, το RFC 7296 ορίζει μια συμπληρωμένη μορφή του μυστικού, που παράγεται με κατακερματισμό του μυστικού με τη σταθερή συμβολοσειρά Key Pad for IKEv2, και έπειτα με κατακερματισμό των υπογεγραμμένων δεδομένων ανταλλαγής και της ταυτότητας με αυτό το συμπληρωμένο κλειδί. Ο επαληθευτής μπορεί να ξαναχτίσει την ίδια τιμή· ένας παρατηρητής δεν μπορεί, χωρίς το μυστικό.
Προσέξτε τι άλλαξε. Στο IKEv1 το μυστικό είναι ψημένο στο χρονοδιάγραμμα κλειδιών πριν υπάρξει ο κατακερματισμός ελέγχου ταυτότητας· στο IKEv2 το χρονοδιάγραμμα κλειδιών είναι ανεξάρτητο από το μυστικό και η απόδειξη είναι ξεχωριστό ωφέλιμο φορτίο δεμένο με τις υπογεγραμμένες οκτάδες. Ίδια εννοιολογική εγγύηση, διαφορετική μηχανή, και γι' αυτό τα ονόματα παραμέτρων και οι καταγραφές δεν αντιστοιχίζονται ένα προς ένα.
Τι μαθαίνει πραγματικά ένας παρατηρητής
Δημόσιες τιμές Ντίφι-Χέλμαν, προτάσεις, νονς και κούκις είναι ορατά και στις δύο εκδόσεις. Οι ταυτότητες είναι ορατές στο επιθετική λειτουργία IKEv1 και προστατευμένες στις άλλες περιπτώσεις. Το μυστικό δεν είναι ποτέ ορατό.
Η τελευταία πρόταση έχει ένα όριο που αξίζει να αναφερθεί. Ένα αδύναμο μυστικό επιλεγμένο από άνθρωπο μπορεί να δεχθεί επίθεση με μαντεψιές: ο επιτιθέμενος υπολογίζει ποια θα ήταν η τιμή ελέγχου ταυτότητας για ένα υποψήφιο μυστικό και συγκρίνει. Το επιθετική λειτουργία IKEv1 το κάνει φθηνότερο από όλα επειδή τα στοιχεία είναι στο φανερό, και τα πρότυπα προειδοποιούν γενικά για μυστικά χαμηλής εντροπίας. Το να μην μεταδίδεται ποτέ το μυστικό δεν είναι το ίδιο με το να κάνεις ένα κακό μυστικό ασφαλές.
Τι να κάνετε με τη σύγκριση
Χρησιμοποιήστε ένα μοναδικό μυστικό ανά ζεύγος ομοτίμων, δημιουργήστε το από τυχαία πηγή και περιστρέψτε το μέσω της ίδιας διαδρομής παροχής που το διακίνησε. Αν το μυστικό αποθηκεύεται σε πρότυπο διαμόρφωσης που αποστέλλεται σε κάθε υποκατάστημα, μια παραβίαση σε ένα σημείο είναι παραβίαση παντού.
Προτιμήστε έλεγχο ταυτότητας βάσει πιστοποιητικών όπου το λειτουργικό κόστος είναι αποδεκτό, αφού εξαλείφει το πρόβλημα μαντέματος του κοινού μυστικού και δίνει σε κάθε ομότιμο ξεχωριστή ταυτότητα. Όπου παραμένει προκοινοποιημένο κλειδί, κρατήστε το μακρύ, περιορίστε το εύρος του και αντιμετωπίστε την έκδοση IKE ως απόφαση ασφαλείας και όχι ως λεπτομέρεια διαλειτουργικότητας.